Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.novell.xml.dom
Class ElementImpl

    java.lang.Object
      com.novell.xml.dom.NodeImpl
          com.novell.xml.dom.ElementImpl

All Implemented Interfaces:
  Cloneable, Comparable, Element, Node

    public class ElementImpl

extends NodeImpl
implements Element

Implementation of DOM level 1 `Element` interface

Field Summary

Fields inherited from class com.novell.xml.dom.NodeImpl
`allowedChildren, baseURI, changeCount, document, documentOrderVal, expandedName, firstChild, lastChild, localName, namespaceURI, nextOrderVal, nextSibling, nodeName, nodeValue, parentNode, prefix, previousSibling, toStringSerializes, xmlnsPrefix, xmlPrefix, xpathBehavior`

Fields inherited from interface org.w3c.dom.Node
`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

Constructor Summary
`protected` | `ElementImpl(DocumentImpl owner, String tagName)` Construct an Element instance with the passed name.
`protected` | `ElementImpl(DocumentImpl owner, String namespaceURI, String qualifiedName)` Construct an Element instance with the passed namespaceURI and qualifiedName.

Method Summary
`protected void` | `checkNamespaceAttr(String attrName)` Check the passed attribute name and if the attribute is a namespace declarations, invalidate the namespace nodes of this and all descendant Elements
`Node` | `cloneNode(boolean deep)` Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes.
`String` | `getAttribute(String name)` Retrieves an attribute value by name.
`Attr` | `getAttributeNode(String name)` Retrieves an `Attr` node by name.
`Attr` | `getAttributeNodeNS(String namespaceURI, String localName)` Retrieves an `Attr` node by local name and namespace URI.
`String` | `getAttributeNS(String namespaceURI, String localName)` Retrieves an attribute value by local name and namespace URI.
`NamedNodeMap` | `getAttributes()` A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.
`NodeList` | `getElementsByTagName(String name)` Returns a `NodeList` of all descendant elements with a given tag name, in the order in which they would be encountered in a preorder traversal of the `Element` tree.
`NodeList` | `getElementsByTagNameNS(String namespaceURI, String localName)` Returns a `NodeList` of all the descendant `Elements` with a given local name and namespace URI in the order in which they are encountered in a preorder traversal of this `Element` tree.
`Attr` | `getIdAttr()` Return the id attribute, if any, for this element Non-DOM
`NamedNodeMap` | `getNamespaces()` A `NamedNodeMap` containing the namespaces of this node (if it is an `Element`) or `null` otherwise.
`short` | `getNodeType()` A code representing the type of the underlying object, as defined above.
`String` | `getTagName()` The name of the element.
`boolean` | `hasAttribute(String name)` Returns `true` when an attribute with a given name is specified on this element or has a default value, `false` otherwise.
`boolean` | `hasAttributeNS(String namespaceURI, String localName)` Returns `true` when an attribute with a given local name and namespace URI is specified on this element or has a default value, `false` otherwise.
`protected void` | `purgeCachedExpandedNames()` purge cached expandedNames
`void` | `removeAttribute(String name)` Removes an attribute by name.
`Attr` | `removeAttributeNode(Attr oldAttr)` Removes the specified attribute.
`void` | `removeAttributeNS(String namespaceURI, String localName)` Removes an attribute by local name and namespace URI.
`void` | `setAttribute(String name, String value)` Adds a new attribute.
`Attr` | `setAttributeNode(Attr newAttr)` Adds a new attribute.
`Attr` | `setAttributeNodeNS(Attr newAttr)` Adds a new attribute.
`void` | `setAttributeNS(String namespaceURI, String qualifiedName, String value)` Adds a new attribute.
`protected void` | `setMapped(boolean isMapped)` Method for DocumentImpl to note that this ElementImpl object is mapped in the id table
`protected int` | `updateDocumentOrder(int order)` Set the document order values for any namespace nodes and attribute nodes belonging to this element.

Methods inherited from class com.novell.xml.dom.NodeImpl
`appendChild, checkName, checkNameNS, compareTo, fetchNamespacesFromDecls, gateModify, getBaseURI, getChangeCount, getChildNodes, getColumnNumber, getDocumentOrder, getExpandedName, getFirstChild, getLastChild, getLineNumber, getLocalName, getNamespaceURI, getNextSibling, getNodeName, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, hasAttributes, hasChildNodes, incChangeCount, insertBefore, isChildAllowed, isReadOnly, isSupported, normalize, removeChild, replaceChild, setBaseURI, setColumnNumber, setDeepReadOnly, setDocumentOrder, setLineNumber, setNodeValue, setOwnerDocument, setPrefix, setReadOnly, setXPathBehavior, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.w3c.dom.Element
`getSchemaTypeInfo, setIdAttribute, setIdAttributeNode, setIdAttributeNS`

Methods inherited from interface org.w3c.dom.Node
`appendChild, compareDocumentPosition, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeName, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasAttributes, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`

Constructor Detail

### ElementImpl

    protected ElementImpl(DocumentImpl owner,
                          String tagName)

  Construct an Element instance with the passed name.

  Parameters:
    `owner` - The owning document that is creating this node.
    `tagName` - The name of the element.

### ElementImpl

    protected ElementImpl(DocumentImpl owner,
                          String namespaceURI,
                          String qualifiedName)

  Construct an Element instance with the passed namespaceURI and qualifiedName.

  Parameters:
    `owner` - The owning document that is creating this node.
    `namespaceURI` - URI string
    `qualifiedName` - namespace-qualified tag name of the element.

Method Detail

### getNodeType

    public short getNodeType()

  A code representing the type of the underlying object, as defined above.

  Specified by:
    `getNodeType` in interface `Node`
  Specified by:
    `getNodeType` in class `NodeImpl`

### getTagName

    public String getTagName()

  The name of the element. For example, in: <elementExample id="demo"> ... </elementExample> , `tagName` has the value `"elementExample"`. Note that this is case-preserving in XML, as are all of the operations of the DOM. The HTML DOM returns the `tagName` of an HTML element in the canonical uppercase form, regardless of the case in the source HTML document.

  Specified by:
    `getTagName` in interface `Element`

### getAttributes

    public NamedNodeMap getAttributes()

  A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.

  Specified by:
    `getAttributes` in interface `Node`
  Overrides:
    `getAttributes` in class `NodeImpl`

### cloneNode

    public Node cloneNode(boolean deep)

  Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes. The duplicate node has no parent ( `parentNode` returns `null`.).
  Cloning an `Element` copies all attributes and their values, including those generated by the XML processor to represent defaulted attributes, but this method does not copy any text it contains unless it is a deep clone, since the text is contained in a child `Text` node. Cloning any other type of node simply returns a copy of this node.

  Specified by:
    `cloneNode` in interface `Node`
  Overrides:
    `cloneNode` in class `NodeImpl`
  Parameters:
    `deep` - If `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself (and its attributes, if it is an `Element`).
  Returns:
    The duplicate node.

### getAttribute

    public String getAttribute(String name)

  Retrieves an attribute value by name.

  Specified by:
    `getAttribute` in interface `Element`
  Parameters:
    `name` - The name of the attribute to retrieve.
  Returns:
    The `Attr` value as a string, or the empty string if that attribute does not have a specified or default value.

### setAttribute

    public void setAttribute(String name,
                             String value)
                      throws DOMException

  Adds a new attribute. If an attribute with that name is already present in the element, its value is changed to be that of the value parameter. This value is a simple string, it is not parsed as it is being set. So any markup (such as syntax to be recognized as an entity reference) is treated as literal text, and needs to be appropriately escaped by the implementation when it is written out. In order to assign an attribute value that contains entity references, the user must create an `Attr` node plus any `Text` and `EntityReference` nodes, build the appropriate subtree, and use `setAttributeNode` to assign it as the value of an attribute.

  Specified by:
    `setAttribute` in interface `Element`
  Parameters:
    `name` - The name of the attribute to create or alter.
    `value` - Value to set in string form.
  Throws:
    `DOMException` - INVALID_CHARACTER_ERR: Raised if the specified name contains an invalid character.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

### removeAttribute

    public void removeAttribute(String name)
                         throws DOMException

  Removes an attribute by name. If the removed attribute has a default value it is immediately replaced.

  Specified by:
    `removeAttribute` in interface `Element`
  Parameters:
    `name` - The name of the attribute to remove.
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

### getAttributeNode

    public Attr getAttributeNode(String name)

  Retrieves an `Attr` node by name.

  Specified by:
    `getAttributeNode` in interface `Element`
  Parameters:
    `name` - The name of the attribute to retrieve.
  Returns:
    The `Attr` node with the specified attribute name or `null` if there is no such attribute.

### setAttributeNode

    public Attr setAttributeNode(Attr newAttr)
                          throws DOMException

  Adds a new attribute. If an attribute with that name is already present in the element, it is replaced by the new one.

  Specified by:
    `setAttributeNode` in interface `Element`
  Parameters:
    `newAttr` - The `Attr` node to add to the attribute list.
  Returns:
    If the `newAttr` attribute replaces an existing attribute with the same name, the previously existing `Attr` node is returned, otherwise `null` is returned.
  Throws:
    `DOMException` - WRONG_DOCUMENT_ERR: Raised if `newAttr` was created from a different document than the one that created the element.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    INUSE_ATTRIBUTE_ERR: Raised if `newAttr` is already an attribute of another `Element` object. The DOM user must explicitly clone `Attr` nodes to re-use them in other elements.

### removeAttributeNode

    public Attr removeAttributeNode(Attr oldAttr)
                             throws DOMException

  Removes the specified attribute.

  Specified by:
    `removeAttributeNode` in interface `Element`
  Parameters:
    `oldAttr` - The `Attr` node to remove from the attribute list. If the removed `Attr` has a default value it is immediately replaced.
  Returns:
    The `Attr` node that was removed.
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    NOT_FOUND_ERR: Raised if `oldAttr` is not an attribute of the element.

### getElementsByTagName

    public NodeList getElementsByTagName(String name)

  Returns a `NodeList` of all descendant elements with a given tag name, in the order in which they would be encountered in a preorder traversal of the `Element` tree.

  Specified by:
    `getElementsByTagName` in interface `Element`
  Parameters:
    `name` - The name of the tag to match on. The special value "*" matches all tags.
  Returns:
    A list of matching `Element` nodes.

### getAttributeNS

    public String getAttributeNS(String namespaceURI,
                                 String localName)

  Retrieves an attribute value by local name and namespace URI. HTML-only DOM implementations do not need to implement this method.

  Specified by:
    `getAttributeNS` in interface `Element`
  Parameters:
    `namespaceURI` - The namespace URI of the attribute to retrieve.
    `localName` - The local name of the attribute to retrieve.
  Returns:
    The `Attr` value as a string, or the empty string if that attribute does not have a specified or default value.
  Since:
    DOM Level 2

### setAttributeNS

    public void setAttributeNS(String namespaceURI,
                               String qualifiedName,
                               String value)
                        throws DOMException

  Adds a new attribute. If an attribute with the same local name and namespace URI is already present on the element, its prefix is changed to be the prefix part of the `qualifiedName`, and its value is changed to be the `value` parameter. This value is a simple string; it is not parsed as it is being set. So any markup (such as syntax to be recognized as an entity reference) is treated as literal text, and needs to be appropriately escaped by the implementation when it is written out. In order to assign an attribute value that contains entity references, the user must create an `Attr` node plus any `Text` and `EntityReference` nodes, build the appropriate subtree, and use `setAttributeNodeNS` or `setAttributeNode` to assign it as the value of an attribute.
  HTML-only DOM implementations do not need to implement this method.

  Specified by:
    `setAttributeNS` in interface `Element`
  Parameters:
    `namespaceURI` - The namespace URI of the attribute to create or alter.
    `qualifiedName` - The qualified name of the attribute to create or alter.
    `value` - The value to set in string form.
  Throws:
    `DOMException` - INVALID_CHARACTER_ERR: Raised if the specified qualified name contains an illegal character.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    NAMESPACE_ERR: Raised if the `qualifiedName` is malformed, if the `qualifiedName` has a prefix and the `namespaceURI` is `null`, if the `qualifiedName` has a prefix that is "xml" and the `namespaceURI` is different from " http://www.w3.org/XML/1998/namespace", or if the `qualifiedName` is "xmlns" and the `namespaceURI` is different from " http://www.w3.org/2000/xmlns/".
  Since:
    DOM Level 2

### removeAttributeNS

    public void removeAttributeNS(String namespaceURI,
                                  String localName)
                           throws DOMException

  Removes an attribute by local name and namespace URI. If the removed attribute has a default value it is immediately replaced. The replacing attribute has the same namespace URI and local name, as well as the original prefix.
  HTML-only DOM implementations do not need to implement this method.

  Specified by:
    `removeAttributeNS` in interface `Element`
  Parameters:
    `namespaceURI` - The namespace URI of the attribute to remove.
    `localName` - The local name of the attribute to remove.
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
  Since:
    DOM Level 2

### getAttributeNodeNS

    public Attr getAttributeNodeNS(String namespaceURI,
                                   String localName)

  Retrieves an `Attr` node by local name and namespace URI. HTML-only DOM implementations do not need to implement this method.

  Specified by:
    `getAttributeNodeNS` in interface `Element`
  Parameters:
    `namespaceURI` - The namespace URI of the attribute to retrieve.
    `localName` - The local name of the attribute to retrieve.
  Returns:
    The `Attr` node with the specified attribute local name and namespace URI or `null` if there is no such attribute.
  Since:
    DOM Level 2

### setAttributeNodeNS

    public Attr setAttributeNodeNS(Attr newAttr)
                            throws DOMException

  Adds a new attribute. If an attribute with that local name and that namespace URI is already present in the element, it is replaced by the new one.
  HTML-only DOM implementations do not need to implement this method.

  Specified by:
    `setAttributeNodeNS` in interface `Element`
  Parameters:
    `newAttr` - The `Attr` node to add to the attribute list.
  Returns:
    If the `newAttr` attribute replaces an existing attribute with the same local name and namespace URI, the replaced `Attr` node is returned, otherwise `null` is returned.
  Throws:
    `DOMException` - WRONG_DOCUMENT_ERR: Raised if `newAttr` was created from a different document than the one that created the element.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    INUSE_ATTRIBUTE_ERR: Raised if `newAttr` is already an attribute of another `Element` object. The DOM user must explicitly clone `Attr` nodes to re-use them in other elements.
  Since:
    DOM Level 2

### getElementsByTagNameNS

    public NodeList getElementsByTagNameNS(String namespaceURI,
                                           String localName)

  Returns a `NodeList` of all the descendant `Elements` with a given local name and namespace URI in the order in which they are encountered in a preorder traversal of this `Element` tree.
  HTML-only DOM implementations do not need to implement this method.

  Specified by:
    `getElementsByTagNameNS` in interface `Element`
  Parameters:
    `namespaceURI` - The namespace URI of the elements to match on. The special value "*" matches all namespaces.
    `localName` - The local name of the elements to match on. The special value "*" matches all local names.
  Returns:
    A new `NodeList` object containing all the matched `Elements`.
  Since:
    DOM Level 2

### hasAttribute

    public boolean hasAttribute(String name)

  Returns `true` when an attribute with a given name is specified on this element or has a default value, `false` otherwise.

  Specified by:
    `hasAttribute` in interface `Element`
  Parameters:
    `name` - The name of the attribute to look for.
  Returns:
    `true` if an attribute with the given name is specified on this element or has a default value, `false` otherwise.
  Since:
    DOM Level 2

### hasAttributeNS

    public boolean hasAttributeNS(String namespaceURI,
                                  String localName)

  Returns `true` when an attribute with a given local name and namespace URI is specified on this element or has a default value, `false` otherwise. HTML-only DOM implementations do not need to implement this method.

  Specified by:
    `hasAttributeNS` in interface `Element`
  Parameters:
    `namespaceURI` - The namespace URI of the attribute to look for.
    `localName` - The local name of the attribute to look for.
  Returns:
    `true` if an attribute with the given local name and namespace URI is specified or has a default value on this element, `false` otherwise.
  Since:
    DOM Level 2

### getIdAttr

    public Attr getIdAttr()

  Return the id attribute, if any, for this element Non-DOM

  Returns:
    The ID attribute node for this element if one exists, null otherwise

### getNamespaces

    public NamedNodeMap getNamespaces()

  A `NamedNodeMap` containing the namespaces of this node (if it is an `Element`) or `null` otherwise. NOTE: This will not be currently maintained as the tree is modified.

### updateDocumentOrder

    protected int updateDocumentOrder(int order)

  Set the document order values for any namespace nodes and attribute nodes belonging to this element.

  Parameters:
    `order` - The starting order value to use.
  Returns:
    The next order value that should be used.

### setMapped

    protected void setMapped(boolean isMapped)

  Method for DocumentImpl to note that this ElementImpl object is mapped in the id table

### checkNamespaceAttr

    protected void checkNamespaceAttr(String attrName)

  Check the passed attribute name and if the attribute is a namespace declarations, invalidate the namespace nodes of this and all descendant Elements

  Parameters:
    `attrName` - The name of the attribute to check.

### purgeCachedExpandedNames

    protected void purgeCachedExpandedNames()

  purge cached expandedNames

  Overrides:
    `purgeCachedExpandedNames` in class `NodeImpl`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD